namespace Quadratic.Carto.MathExt;


public static partial class VectorsExt
{
    public static Godot.Vector3 AsGodot(this Vim.Math3d.Vector3 v)
    {
        return new Godot.Vector3(v.X, v.Y, v.Z);
    }

    public static Vim.Math3d.Vector3 AsVim(this Godot.Vector3 v)
    {
        return new Vim.Math3d.Vector3(v.X, v.Y, v.Z);
    }

    public static System.Numerics.Vector3 AsSystem(this Vim.Math3d.Vector3 v)
    {
        return new System.Numerics.Vector3(v.X, v.Y, v.Z);
    }

    public static Vim.Math3d.Vector3 AsVim(this System.Numerics.Vector3 v)
    {
        return new Vim.Math3d.Vector3(v.X, v.Y, v.Z);
    }

    public static Godot.Vector3 AsGodot(this System.Numerics.Vector3 v)
    {
        return new Godot.Vector3(v.X, v.Y, v.Z);
    }

    public static System.Numerics.Vector3 AsSystem(this Godot.Vector3 v)
    {
        return new System.Numerics.Vector3(v.X, v.Y, v.Z);
    }

    public static DVector3 AsDouble(this Vim.Math3d.Vector3 v)
    {
        return new DVector3(v.X, v.Y, v.Z);
    }

    public static Vim.Math3d.Vector3 AsSingle(this DVector3 v)
    {
        return new Vim.Math3d.Vector3((float)v.X, (float)v.Y, (float)v.Z);
    }

    public static Godot.Vector2 AsGodot(this Vim.Math3d.Vector2 v)
    {
        return new Godot.Vector2(v.X, v.Y);
    }

    public static Vim.Math3d.Vector2 AsVim(this Godot.Vector2 v)
    {
        return new Vim.Math3d.Vector2(v.X, v.Y);
    }

    public static System.Numerics.Vector2 AsSystem(this Vim.Math3d.Vector2 v)
    {
        return new System.Numerics.Vector2(v.X, v.Y);
    }

    public static Vim.Math3d.Vector2 AsVim(this System.Numerics.Vector2 v)
    {
        return new Vim.Math3d.Vector2(v.X, v.Y);
    }

    public static Godot.Vector2 AsGodot(this System.Numerics.Vector2 v)
    {
        return new Godot.Vector2(v.X, v.Y);
    }

    public static System.Numerics.Vector2 AsSystem(this Godot.Vector2 v)
    {
        return new System.Numerics.Vector2(v.X, v.Y);
    }

    public static Godot.Quaternion AsGodot(this Vim.Math3d.Quaternion q)
    {
        return new Godot.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static Vim.Math3d.Quaternion AsVim(this Godot.Quaternion q)
    {
        return new Vim.Math3d.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static System.Numerics.Quaternion AsSystem(this Vim.Math3d.Quaternion q)
    {
        return new System.Numerics.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static Vim.Math3d.Quaternion AsVim(this System.Numerics.Quaternion q)
    {
        return new Vim.Math3d.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static Godot.Quaternion AsGodot(this System.Numerics.Quaternion q)
    {
        return new Godot.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static System.Numerics.Quaternion AsSystem(this Godot.Quaternion q)
    {
        return new System.Numerics.Quaternion(q.X, q.Y, q.Z, q.W);
    }

    public static Godot.Vector4 AsGodot(this Vim.Math3d.Vector4 v)
    {
        return new Godot.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static Vim.Math3d.Vector4 AsVim(this Godot.Vector4 v)
    {
        return new Vim.Math3d.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static System.Numerics.Vector4 AsSystem(this Vim.Math3d.Vector4 v)
    {
        return new System.Numerics.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static Vim.Math3d.Vector4 AsVim(this System.Numerics.Vector4 v)
    {
        return new Vim.Math3d.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static Godot.Vector4 AsGodot(this System.Numerics.Vector4 v)
    {
        return new Godot.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static System.Numerics.Vector4 AsSystem(this Godot.Vector4 v)
    {
        return new System.Numerics.Vector4(v.X, v.Y, v.Z, v.W);
    }

    public static Vim.Math3d.Ray AsVim(this Ray ray)
    {
        return new Vim.Math3d.Ray(ray.origin.AsVim(), ray.direction.AsVim());
    }

    public static Ray AsGodot(this Vim.Math3d.Ray ray)
    {
        return new Ray(ray.Position.AsGodot(), ray.Direction.AsGodot());
    }
}



